//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TrackRuntime.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {
     VWTrack = new TVWTrackMouse( this );
     VWTrack->Bounding = false;
     VWTrack->OnMouseEnter = VWTrackMouseEnter;
     VWTrack->OnMouseLeave = VWTrackMouseLeave;
     // Add the menu panels.
     VWTrack->Controls->Add( pnlAdd );
     VWTrack->Controls->Add( pnlRun );
     VWTrack->Controls->Add( pnlRemove );
     VWTrack->Controls->Add( pnlRemoveAll );
     VWTrack->Controls->Add( pnlDestroy );
     Timer1->Enabled = true;
     // Set BevelOuter of Panels to bvNone
     Panel1->BevelOuter = bvNone;
     Panel2->BevelOuter = bvNone;
     Panel3->BevelOuter = bvNone;
     Panel4->BevelOuter = bvNone;
     Panel5->BevelOuter = bvNone;
     Tag = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VWTrackMouseEnter( TObject *Sender ) {
     TRect Rect;
     // You can use IsClass or...
     if( IsClass(Sender->ClassType(), "TPanel") ) {
          if( ((TPanel *)Sender)->Name == "pnlImage" ) {
               imgTrack->Picture->LoadFromFile("d:\\projects\\track\\delphi\\VWTrackMouse.bmp");
               ((TPanel *)Sender)->Color = (Graphics::TColor) 0x00414141;
               ((TPanel *)Sender)->BevelOuter = bvRaised;
          }
          else {
               if( ((TPanel *)Sender)->Enabled )
                    ((TPanel *)Sender)->Color = (Graphics::TColor) 0x00414141;
               else
                    ((TPanel *)Sender)->Color = clSilver;
               ((TPanel *)Sender)->Cursor = crHandPoint;
          }
     }
     // ... use this way. You're the who knows.
     else if( (AnsiString(((TControl *)Sender)->ClassName()) == "TEdit")
     ||  (AnsiString(((TControl *)Sender)->ClassName()) == "TLabel")
     ||  (AnsiString(((TControl *)Sender)->ClassName()) == "TButton") ) {
          Rect.Left   = ((TEdit *)Sender)->Left-2;
          Rect.Top    = ((TEdit *)Sender)->Top-2;
          Rect.Right  = ((TEdit *)Sender)->Left + ((TEdit *)Sender)->Width + 2;
          Rect.Bottom = ((TEdit *)Sender)->Top + ((TEdit *)Sender)->Height + 2;
          Canvas->Brush->Color = clBlue;
          Canvas->FrameRect( Rect );
     }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VWTrackMouseLeave( TObject *Sender ) {
     TRect Rect;
     // You can use IsClass or...
     if( IsClass(Sender->ClassType(), "TPanel") ) {
          if( ((TPanel *)Sender)->Name == "pnlImage" ) {
               imgTrack->Picture->LoadFromFile("d:\\projects\\track\\delphi\\VWTrackMouse2.bmp");
               ((TPanel *)Sender)->Color = clGray;
               ((TPanel *)Sender)->BevelOuter = bvNone;
          }
          else {
               if( ((TPanel *)Sender)->Enabled )
                    ((TPanel *)Sender)->Color = clGray;
               else
                    ((TPanel *)Sender)->Color = clSilver;
               ((TPanel *)Sender)->Cursor = crDefault;
          }
     }
     // ... use this way. You're the who knows.
     else if( (AnsiString(((TControl *)Sender)->ClassName()) == "TEdit")
     ||  (AnsiString(((TControl *)Sender)->ClassName()) == "TLabel")
     ||  (AnsiString(((TControl *)Sender)->ClassName()) == "TButton") ) {
          Rect.Left   = ((TEdit *)Sender)->Left-2;
          Rect.Top    = ((TEdit *)Sender)->Top-2;
          Rect.Right  = ((TEdit *)Sender)->Left + ((TEdit *)Sender)->Width + 2;
          Rect.Bottom = ((TEdit *)Sender)->Top + ((TEdit *)Sender)->Height + 2;
          Canvas->Brush->Color = clSilver;
          Canvas->FrameRect( Rect );
     }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pnlRunClick(TObject *Sender) {
     VWTrack->Run();
     Timer1->Enabled = false;
     pnlRun->Font->Color = clWhite;
     pnlRun->Caption = "Run VWTrackMouse ";
     // Enable the panels
     pnlAdd->Enabled = true;
     pnlRemove->Enabled = true;
     pnlRemoveAll->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender) {
     if( Timer1->Tag == 0 ) {
          pnlRun->Color = clAqua;
          pnlRun->Font->Color = clBlack;
          pnlRun->Caption = "Click me ";
          Timer1->Tag = 1;
     }
     else {
          pnlRun->Color = clGray;
          pnlRun->Font->Color = clWhite;
          pnlRun->Caption = "Run VWTrackMouse ";
          Timer1->Tag = 0;
     }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pnlAddClick(TObject *Sender) {
     VWTrack->Controls->Add( Edit1 );
     VWTrack->Controls->Add( Button2 );
     VWTrack->Controls->Add( Label1 );
     VWTrack->Controls->Add( pnlImage );
     VWTrack->Controls->Add( Panel1 );
     VWTrack->Controls->Add( Panel2 );
     VWTrack->Controls->Add( Panel3 );
     VWTrack->Controls->Add( Panel4 );
     VWTrack->Controls->Add( Panel5 );
     pnlAdd->Enabled = false;
     pnlRemoveAll->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pnlRemoveClick(TObject *Sender) {
     if( VWTrack->Controls->Remove( pnlImage ) == -1 )
          MessageBox( NULL, "The control 'pnlImage' have been removed.", "Error", (MB_ICONERROR | MB_OK) );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pnlRemoveAllClick(TObject *Sender) {
     VWTrack->Controls->Remove( Edit1 );
     VWTrack->Controls->Remove( Button2 );
     VWTrack->Controls->Remove( Label1 );
     VWTrack->Controls->Remove( pnlImage );
     VWTrack->Controls->Remove( Panel1 );
     VWTrack->Controls->Remove( Panel2 );
     VWTrack->Controls->Remove( Panel3 );
     VWTrack->Controls->Remove( Panel4 );
     VWTrack->Controls->Remove( Panel5 );
     pnlAdd->Enabled = true;
     pnlRemoveAll->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pnlDestroyClick(TObject *Sender) {
     delete VWTrack;
     Close();
}
//---------------------------------------------------------------------------

