unit TrackForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
  VWTrackMouse;

type
  TFormDemo = class(TForm)
    pnlLabels: TPanel;
    lblLink: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    pnlBounding: TPanel;
    pnlMessage: TPanel;
    pnlChildMessage: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Button1: TButton;
    pnlTesting: TPanel;
    pnlThe: TPanel;
    chkboxBounding: TCheckBox;
    Bevel3: TBevel;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Bevel4: TBevel;
    Bevel5: TBevel;
    lblAdditioned: TLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    pnlPanels: TPanel;
    pnlAbout: TPanel;
    pnlAdd: TPanel;
    pnlExit: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    pnlRemove: TPanel;
    Bevel2: TBevel;
    VWTrack: TVWTrackMouse;
    procedure VWTrackMouseEnter(Sender: TObject);
    procedure VWTrackMouseLeave(Sender: TObject);
    procedure pnlLabelsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlLabelsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure chkboxBoundingClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormDemo: TFormDemo;

implementation

uses TrackAbout;

{$R *.DFM}

procedure TFormDemo.VWTrackMouseEnter(Sender: TObject);
begin
     if TControl(Sender).ClassName = 'TLabel' then begin
          TLabel(Sender).Font.Style := [fsUnderline, fsBold];
     end
     else if TControl(Sender).ClassName = 'TEdit' then begin
          TEdit(Sender).Color := clSilver;
     end
     else if TControl(Sender).ClassName = 'TButton' then begin
          TButton(Sender).Font.Style := [fsUnderline, fsBold];
     end
     else if TControl(Sender).ClassName = 'TCheckBox' then begin
          TCheckBox(Sender).Checked := not TCheckBox(Sender).Checked;
          TCheckBox(Sender).Font.Color := clWhite;
     end
     else if TControl(Sender).ClassName = 'TBevel' then begin
          TBevel(Sender).Style := bsRaised;
     end
     else if TControl(Sender).ClassName = 'TRadioButton' then begin
          TRadioButton(Sender).Font.Style := [fsBold];
     end
     else if TControl(Sender).ClassName = 'TFormDemo' then begin
          ;//TForm(Sender).Font.Style := [fsBold];
     end
     else begin
          TPanel(Sender).Color := clAqua;
          TPanel(Sender).Font.Color := clBlack;
          TPanel(Sender).BevelOuter := bvRaised;
     end;
     lblAdditioned.Caption := 'Controls Additioned: ' + IntToStr(VWTrack.Controls.Count);
end;

procedure TFormDemo.VWTrackMouseLeave(Sender: TObject);
begin
     if TControl(Sender).ClassName = 'TLabel' then begin
          TLabel(Sender).Font.Style := [fsBold];
     end
     else if TControl(Sender).ClassName = 'TEdit' then begin
          TEdit(Sender).Color := clGray;
     end
     else if TControl(Sender).ClassName = 'TButton' then begin
          TButton(Sender).Font.Style := [];
     end
     else if TControl(Sender).ClassName = 'TCheckBox' then begin
          TCheckBox(Sender).Checked := not TCheckBox(Sender).Checked;
          TCheckBox(Sender).Font.Color := clSilver;
     end
     else if TControl(Sender).ClassName = 'TBevel' then begin
          TBevel(Sender).Style := bsLowered;
     end
     else if TControl(Sender).ClassName = 'TRadioButton' then begin
          TRadioButton(Sender).Font.Style := [];
     end
     else if TControl(Sender).ClassName = 'TFormDemo' then begin
          ;//TForm(Sender).Font.Style := [fsBold];
     end
     else begin
          TPanel(Sender).Color := $414141;
          TPanel(Sender).Font.Color := clWhite;
          TPanel(Sender).BevelOuter := bvNone;
     end;
     lblAdditioned.Caption := 'Controls Additioned: ' + IntToStr(VWTrack.Controls.Count);
end;

procedure TFormDemo.pnlLabelsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     TPanel(Sender).BevelOuter := bvLowered;
end;

procedure TFormDemo.pnlLabelsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     TPanel(Sender).BevelOuter := bvRaised;
     if TPanel(Sender).Caption = 'Exit' then
          Close
     else if TPanel(Sender).Caption = 'About' then
          FormAbout.ShowModal
     else if TPanel(Sender).Caption = 'Add' then begin
          pnlPanels.Visible := true;
          if VWTrack.Controls.IndexOf( pnlPanels ) <> -1 then
               MessageBox( 0, PChar('The control ''pnlPanels'' is already additioned.'), PChar('Adding Control'), (MB_ICONERROR or MB_OK) )
          else
              VWTrack.Controls.Add( pnlPanels );
     end
     else if TPanel(Sender).Caption = 'Remove' then begin
          pnlPanels.Visible := false;
          if VWTrack.Controls.Remove( pnlPanels ) = -1 then
               MessageBox( 0, PChar('The control ''pnlPanels'' haven''t been additioned.'), PChar('Removing Control'), (MB_ICONERROR or MB_OK) );
     end;
end;

procedure TFormDemo.chkboxBoundingClick(Sender: TObject);
begin
     VWTrack.Bounding := chkboxBounding.Checked;
     FormAbout.VWTrackAbout.Bounding := chkboxBounding.Checked;
end;










end.
